using System;
using System.Collections.Generic;
using System.Text;

namespace QD_GUI
{
    public class QueueDump
    {
        /* <!DOCTYPE queue_dump [
         *   <!ELEMENT queue_dump           (
         *                                   qd,
         *                                   qdinfo?,
         *                                   notice*,
         *                                   error?,
         *                                   queue?
         *                                  )>
         *   <!ELEMENT qd                   (
         *                                   date,
         *                                   functional_revision
         *                                  )>
         *   <!ELEMENT date                 (#PCDATA)>
         *   <!ELEMENT functional_revision  (#PCDATA)>
         *   <!ELEMENT qdinfo               (#PCDATA)>
         *   <!ELEMENT notice               (#PCDATA)>
         *   <!ELEMENT error                (#PCDATA)>
         *   <!ELEMENT queue                (
         *                                   version,
         *                                   system_type?,
         *                                   warning?,
         *                                   current_index,
         *                                   index+,
         *                                   download_rate?,
         *                                   upload_rate?,
         *                                   performance_fraction?,
         *                                   pph?,
         *                                   ppd?,
         *                                   ppw?,
         *                                   ppy?
         *                                  )>
         *   <!ELEMENT version              (#PCDATA)>
         *   <!ELEMENT system_type          (#PCDATA)>
         *   <!ELEMENT warning              (#PCDATA)>
         *   <!ELEMENT current_index        (#PCDATA)>
         *   <!ELEMENT index                (
         *                                   number,
         *                                   status,
         *                                   credit?,
         *                                   credit_per_hour?,
         *                                   progress_rate?,
         *                                   progress?,
         *                                   server*,
         *                                   project_number,
         *                                   project_name?,
         *                                   genome*,
         *                                   folding*,
         *                                   issue_timestamp,
         *                                   begin_timestamp,
         *                                   end_timestamp?,
         *                                   expect_timestamp?,
         *                                   due_timestamp?,
         *                                   expire_timestamp?,
         *                                   end_in?,
         *                                   expect_in?,
         *                                   due_in?,
         *                                   expire_in?,
         *                                   core,
         *                                   cpu?,
         *                                   os?,
         *                                   assignment_info?,
         *                                   collection_server?,
         *                                   download_timestamp?,
         *                                   upload_failures?,
         *                                   packet_size_limit?,
         *                                   tag?,
         *                                   username,
         *                                   team?,
         *                                   id,
         *                                   machine_id?,
         *                                   work_unit?
         *                                  )>
         *   <!ELEMENT number               (#PCDATA)>
         *   <!ELEMENT status               (#PCDATA)>
         *   <!ELEMENT credit               (#PCDATA)>
         *   <!ELEMENT credit_per_hour      (#PCDATA)>
         *   <!ELEMENT progress_rate        (#PCDATA)>
         *   <!ELEMENT progress             (#PCDATA)>
         *   <!ELEMENT server               (
         *                                   number,
         *                                   address
         *                                  )>
         *   <!ELEMENT address              (#PCDATA)>
         *   <!ELEMENT project_number       (#PCDATA)>
         *   <!ELEMENT project_name         (#PCDATA)>
         *   <!ELEMENT genome               (
         *                                   unit?,
         *                                   benchmark?,
         *                                   misc?,
         *                                   other?
         *                                  )>
         *   <!ELEMENT unit                 (#PCDATA)>
         *   <!ELEMENT benchmark            (#PCDATA)>
         *   <!ELEMENT misc                 (#PCDATA)>
         *   <!ELEMENT other                (#PCDATA)>
         *   <!ELEMENT folding              (
         *                                   run?,
         *                                   clone?,
         *                                   generation?,
         *                                   benchmark?,
         *                                   misc?,
         *                                   other?
         *                                  )>
         *   <!ELEMENT run                  (#PCDATA)>
         *   <!ELEMENT clone                (#PCDATA)>
         *   <!ELEMENT generation           (#PCDATA)>
         *   <!ELEMENT issue_timestamp      (#PCDATA)>
         *   <!ELEMENT begin_timestamp      (#PCDATA)>
         *   <!ELEMENT end_timestamp        (#PCDATA)>
         *   <!ELEMENT expect_timestamp     (#PCDATA)>
         *   <!ELEMENT due_timestamp        (#PCDATA)>
         *   <!ELEMENT expire_timestamp     (#PCDATA)>
         *   <!ELEMENT end_in               (#PCDATA)>
         *   <!ELEMENT expect_in            (#PCDATA)>
         *   <!ELEMENT due_in               (#PCDATA)>
         *   <!ELEMENT expire_in            (#PCDATA)>
         *   <!ELEMENT core                 (
         *                                   url?,
         *                                   version?
         *                                  )>
         *   <!ELEMENT url                  (#PCDATA)>
         *   <!ELEMENT cpu                  (
         *                                   cosm_type?,
         *                                   cosm_subtype?,
         *                                   name?
         *                                  )>
         *   <!ELEMENT cosm_type            (#PCDATA)>
         *   <!ELEMENT cosm_subtype         (#PCDATA)>
         *   <!ELEMENT name                 (#PCDATA)>
         *   <!ELEMENT os                   (
         *                                   cosm_type?,
         *                                   cosm_subtype?,
         *                                   name?
         *                                  )>
         *   <!ELEMENT assignment_info      (
         *                                   byte_order?,
         *                                   timestamp?,
         *                                   checksum?
         *                                  )>
         *   <!ELEMENT byte_order           (#PCDATA)>
         *   <!ELEMENT timestamp            (#PCDATA)>
         *   <!ELEMENT checksum             (#PCDATA)>
         *   <!ELEMENT collection_server    (#PCDATA)>
         *   <!ELEMENT download_timestamp   (#PCDATA)>
         *   <!ELEMENT upload_failures      (#PCDATA)>
         *   <!ELEMENT packet_size_limit    (#PCDATA)>
         *   <!ELEMENT tag                  (#PCDATA)>
         *   <!ELEMENT username             (#PCDATA)>
         *   <!ELEMENT team                 (#PCDATA)>
         *   <!ELEMENT id                   (#PCDATA)>
         *   <!ELEMENT machine_id           (#PCDATA)>
         *   <!ELEMENT work_unit            (
         *                                   file,
         *                                   size,
         *                                   type?
         *                                  )>
         *   <!ELEMENT file                 (#PCDATA)>
         *   <!ELEMENT size                 (#PCDATA)>
         *   <!ELEMENT type                 (#PCDATA)>
         *   <!ELEMENT download_rate        (
         *                                   speed,
         *                                   units
         *                                  )>
         *   <!ELEMENT speed                (#PCDATA)>
         *   <!ELEMENT units                (#PCDATA)>
         *   <!ELEMENT upload_rate          (
         *                                   speed,
         *                                   units
         *                                  )>
         *   <!ELEMENT performance_fraction (
         *                                   fraction,
         *                                   units
         *                                  )>
         *   <!ELEMENT fraction             (#PCDATA)>
         *   <!ELEMENT pph                  (#PCDATA)>
         *   <!ELEMENT ppd                  (#PCDATA)>
         *   <!ELEMENT ppw                  (#PCDATA)>
         *   <!ELEMENT ppy                  (#PCDATA)>
         * ]>
         * 
         * QueueDump.QD.Date
         * QueueDump.QD.FunctionalRevision
         * QueueDump.QDInfo
         * QueueDump.Notice
         * QueueDump.Error
         * QueueDump.Queue.Version
         * QueueDump.Queue.SystemType
         * QueueDump.Queue.Warning
         * QueueDump.Queue.CurrentIndex
         * QueueDump.Queue.Index[0].Number
         * QueueDump.Queue.Index[0].Status
         * QueueDump.Queue.Index[0].Credit
         * QueueDump.Queue.Index[0].CreditPerHour
         * QueueDump.Queue.Index[0].ProgressRate
         * QueueDump.Queue.Index[0].Progress
         * QueueDump.Queue.Index[0].Server[0].Number
         * QueueDump.Queue.Index[0].Server[0].Address
         * QueueDump.Queue.Index[0].ProjectNumber
         * QueueDump.Queue.Index[0].ProjectName
         * QueueDump.Queue.Index[0].Genome.Unit
         * QueueDump.Queue.Index[0].Genome.Benchmark
         * QueueDump.Queue.Index[0].Genome.Misc
         * QueueDump.Queue.Index[0].Genome.Other
         * QueueDump.Queue.Index[0].Folding.Run
         * QueueDump.Queue.Index[0].Folding.Clone
         * QueueDump.Queue.Index[0].Folding.Generation
         * QueueDump.Queue.Index[0].Folding.Benchmark
         * QueueDump.Queue.Index[0].Folding.Misc
         * QueueDump.Queue.Index[0].Folding.Other
         * QueueDump.Queue.Index[0].IssueTimestamp
         * QueueDump.Queue.Index[0].BeginTimestamp
         * QueueDump.Queue.Index[0].EndTimestamp
         * QueueDump.Queue.Index[0].ExpectTimestamp
         * QueueDump.Queue.Index[0].DueTimestamp
         * QueueDump.Queue.Index[0].ExpireTimestamp
         * QueueDump.Queue.Index[0].EndIn
         * QueueDump.Queue.Index[0].ExpectIn
         * QueueDump.Queue.Index[0].DueIn
         * QueueDump.Queue.Index[0].ExpireIn
         * QueueDump.Queue.Index[0].Core.URL
         * QueueDump.Queue.Index[0].Core.Version
         * QueueDump.Queue.Index[0].CPU.CosmType
         * QueueDump.Queue.Index[0].CPU.CosmSubtype
         * QueueDump.Queue.Index[0].CPU.Name
         * QueueDump.Queue.Index[0].OS.CosmType
         * QueueDump.Queue.Index[0].OS.CosmSubtype
         * QueueDump.Queue.Index[0].OS.Name
         * QueueDump.Queue.Index[0].AssignmentInfo.ByteOrder
         * QueueDump.Queue.Index[0].AssignmentInfo.Timestamp
         * QueueDump.Queue.Index[0].AssignmentInfo.Checksum
         * QueueDump.Queue.Index[0].CollectionServer
         * QueueDump.Queue.Index[0].DownloadTimestamp
         * QueueDump.Queue.Index[0].UploadFailures
         * QueueDump.Queue.Index[0].PacketSizeLimit
         * QueueDump.Queue.Index[0].Tag
         * QueueDump.Queue.Index[0].Username
         * QueueDump.Queue.Index[0].Team
         * QueueDump.Queue.Index[0].ID
         * QueueDump.Queue.Index[0].MachineID
         * QueueDump.Queue.Index[0].WorkUnit.File
         * QueueDump.Queue.Index[0].WorkUnit.Size
         * QueueDump.Queue.Index[0].WorkUnit.Type
         * ...
         * QueueDump.Queue.Index[9]
         * QueueDump.Queue.DownloadRate.Speed
         * QueueDump.Queue.DownloadRate.Units
         * QueueDump.Queue.UploadRate.Speed
         * QueueDump.Queue.UploadRate.Units
         * QueueDump.Queue.PerformanceFraction.Fraction
         * QueueDump.Queue.PerformanceFraction.Units
         * QueueDump.Queue.PPH
         * QueueDump.Queue.PPD
         * QueueDump.Queue.PPW
         * QueueDump.Queue.PPY
         */

        private QD oQD = new QD();
        private QDInfo oQDInfo = new QDInfo();
        private List<string> oNotice = new List<string>();
        private string sError = "";
        private Queue oQueue = new Queue();

        #region Properties

        public QD QD
        {
            get
            {
                return oQD;
            }
            set
            {
                oQD = value;
            }
        }

        public QDInfo QDInfo
        {
            get
            {
                return oQDInfo;
            }
            set
            {
                oQDInfo = value;
            }
        }
        
        public List<string> Notice
        {
            get
            {
                return oNotice;
            }
            set
            {
                oNotice = value;
            }
        }

        public string Error
        {
            get
            {
                return sError;
            }
            set
            {
                sError = value;
            }
        }        

        public Queue Queue
        {
            get
            {
                return oQueue;
            }
            set
            {
                oQueue = value;
            }
        }

        #endregion Properties
    }
}
